# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing_extensions import Literal, Required, Annotated, TypedDict

from ..._utils import PropertyInfo

__all__ = ["UsageTrackChatParams"]


class UsageTrackChatParams(TypedDict, total=False):
    input_tokens: Required[Annotated[float, PropertyInfo(alias="inputTokens")]]
    """Number of input tokens"""

    model: Required[
        Literal[
            "openai:gpt-4.1",
            "openai:gpt-4o",
            "openai:gpt-4o-mini",
            "openai:gpt-4",
            "openai:gpt-3.5-turbo",
            "openai:o1",
            "openai:o1-mini",
            "openai:o3-mini",
            "anthropic:claude-3-opus",
            "anthropic:claude-3-sonnet",
            "anthropic:claude-3-haiku",
            "google:gemini-pro",
            "meta:llama-3",
        ]
    ]
    """AI model used"""

    output_tokens: Required[Annotated[float, PropertyInfo(alias="outputTokens")]]
    """Number of output tokens"""

    session_id: Required[Annotated[str, PropertyInfo(alias="sessionId")]]
    """Chat session ID"""

    component_id: Annotated[str, PropertyInfo(alias="componentId")]
    """Component ID"""

    group_id: Annotated[str, PropertyInfo(alias="groupId")]
    """Group ID"""

    metadata: object
    """Additional metadata"""

    reasoning_tokens: Annotated[float, PropertyInfo(alias="reasoningTokens")]
    """Number of reasoning tokens"""

    user_id: Annotated[str, PropertyInfo(alias="userId")]
    """User ID"""
