# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing_extensions import Literal, Required, Annotated, TypedDict

from ..._utils import PropertyInfo

__all__ = ["UsageTrackEventParams"]


class UsageTrackEventParams(TypedDict, total=False):
    event_type: Required[
        Annotated[
            Literal[
                "material_created",
                "material_uploaded",
                "material_processed",
                "material_deleted",
                "component_created",
                "component_accessed",
                "component_deleted",
                "component_usage",
                "chat_message_sent",
                "chat_session_started",
                "chat_session_ended",
                "test_created",
                "test_started",
                "test_completed",
                "test_question_answered",
                "test_retaken",
                "audio_recap_create",
                "api_call",
                "cache_hit",
                "sso_login",
                "sso_logout",
                "student_performance",
            ],
            PropertyInfo(alias="eventType"),
        ]
    ]
    """Type of usage event"""

    cache_hit: Annotated[bool, PropertyInfo(alias="cacheHit")]
    """Whether response was served from cache"""

    component_name: Annotated[str, PropertyInfo(alias="componentName")]
    """Component name"""

    component_type: Annotated[str, PropertyInfo(alias="componentType")]
    """Component type"""

    content_size: Annotated[float, PropertyInfo(alias="contentSize")]
    """Size of content in bytes"""

    endpoint: str
    """API endpoint accessed"""

    file_size: Annotated[float, PropertyInfo(alias="fileSize")]
    """File size in bytes"""

    file_type: Annotated[str, PropertyInfo(alias="fileType")]
    """File MIME type"""

    group_id: Annotated[str, PropertyInfo(alias="groupId")]
    """Group ID for collaborative sessions"""

    input_tokens: Annotated[float, PropertyInfo(alias="inputTokens")]
    """Number of input tokens"""

    ip_address: Annotated[str, PropertyInfo(alias="ipAddress")]
    """Client IP address"""

    metadata: object
    """Additional metadata"""

    method: str
    """HTTP method used"""

    model: Literal[
        "openai:gpt-4.1",
        "openai:gpt-4o",
        "openai:gpt-4o-mini",
        "openai:gpt-4",
        "openai:gpt-3.5-turbo",
        "openai:o1",
        "openai:o1-mini",
        "openai:o3-mini",
        "anthropic:claude-3-opus",
        "anthropic:claude-3-sonnet",
        "anthropic:claude-3-haiku",
        "google:gemini-pro",
        "meta:llama-3",
    ]
    """AI model used"""

    output_tokens: Annotated[float, PropertyInfo(alias="outputTokens")]
    """Number of output tokens"""

    performance_data: Annotated[object, PropertyInfo(alias="performanceData")]
    """Performance metrics data"""

    reasoning_tokens: Annotated[float, PropertyInfo(alias="reasoningTokens")]
    """Number of reasoning tokens"""

    resource_id: Annotated[str, PropertyInfo(alias="resourceId")]
    """Resource ID being accessed"""

    resource_type: Annotated[str, PropertyInfo(alias="resourceType")]
    """Type of resource"""

    response_time: Annotated[float, PropertyInfo(alias="responseTime")]
    """Response time in milliseconds"""

    session_id: Annotated[str, PropertyInfo(alias="sessionId")]
    """Session ID"""

    status_code: Annotated[float, PropertyInfo(alias="statusCode")]
    """HTTP status code"""

    total_tokens: Annotated[float, PropertyInfo(alias="totalTokens")]
    """Total number of tokens"""

    user_agent: Annotated[str, PropertyInfo(alias="userAgent")]
    """Client user agent"""

    user_id: Annotated[str, PropertyInfo(alias="userId")]
    """User ID"""
