# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from studyfetch_sdk import StudyfetchSDK, AsyncStudyfetchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestNumber2fa:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_disable(self, client: StudyfetchSDK) -> None:
        number_2fa = client.v1.auth.number_2fa.disable(
            password="password123",
        )
        assert number_2fa is None

    @parametrize
    def test_raw_response_disable(self, client: StudyfetchSDK) -> None:
        response = client.v1.auth.number_2fa.with_raw_response.disable(
            password="password123",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = response.parse()
        assert number_2fa is None

    @parametrize
    def test_streaming_response_disable(self, client: StudyfetchSDK) -> None:
        with client.v1.auth.number_2fa.with_streaming_response.disable(
            password="password123",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_method_enable(self, client: StudyfetchSDK) -> None:
        number_2fa = client.v1.auth.number_2fa.enable(
            password="password123",
        )
        assert number_2fa is None

    @parametrize
    def test_raw_response_enable(self, client: StudyfetchSDK) -> None:
        response = client.v1.auth.number_2fa.with_raw_response.enable(
            password="password123",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = response.parse()
        assert number_2fa is None

    @parametrize
    def test_streaming_response_enable(self, client: StudyfetchSDK) -> None:
        with client.v1.auth.number_2fa.with_streaming_response.enable(
            password="password123",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_method_get_status(self, client: StudyfetchSDK) -> None:
        number_2fa = client.v1.auth.number_2fa.get_status()
        assert number_2fa is None

    @parametrize
    def test_raw_response_get_status(self, client: StudyfetchSDK) -> None:
        response = client.v1.auth.number_2fa.with_raw_response.get_status()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = response.parse()
        assert number_2fa is None

    @parametrize
    def test_streaming_response_get_status(self, client: StudyfetchSDK) -> None:
        with client.v1.auth.number_2fa.with_streaming_response.get_status() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_method_regenerate_backup_codes(self, client: StudyfetchSDK) -> None:
        number_2fa = client.v1.auth.number_2fa.regenerate_backup_codes(
            password="password123",
        )
        assert number_2fa is None

    @parametrize
    def test_raw_response_regenerate_backup_codes(self, client: StudyfetchSDK) -> None:
        response = client.v1.auth.number_2fa.with_raw_response.regenerate_backup_codes(
            password="password123",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = response.parse()
        assert number_2fa is None

    @parametrize
    def test_streaming_response_regenerate_backup_codes(self, client: StudyfetchSDK) -> None:
        with client.v1.auth.number_2fa.with_streaming_response.regenerate_backup_codes(
            password="password123",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_method_send_code(self, client: StudyfetchSDK) -> None:
        number_2fa = client.v1.auth.number_2fa.send_code(
            email="user@example.com",
        )
        assert number_2fa is None

    @parametrize
    def test_raw_response_send_code(self, client: StudyfetchSDK) -> None:
        response = client.v1.auth.number_2fa.with_raw_response.send_code(
            email="user@example.com",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = response.parse()
        assert number_2fa is None

    @parametrize
    def test_streaming_response_send_code(self, client: StudyfetchSDK) -> None:
        with client.v1.auth.number_2fa.with_streaming_response.send_code(
            email="user@example.com",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True


class TestAsyncNumber2fa:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @parametrize
    async def test_method_disable(self, async_client: AsyncStudyfetchSDK) -> None:
        number_2fa = await async_client.v1.auth.number_2fa.disable(
            password="password123",
        )
        assert number_2fa is None

    @parametrize
    async def test_raw_response_disable(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.auth.number_2fa.with_raw_response.disable(
            password="password123",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = await response.parse()
        assert number_2fa is None

    @parametrize
    async def test_streaming_response_disable(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.auth.number_2fa.with_streaming_response.disable(
            password="password123",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = await response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_method_enable(self, async_client: AsyncStudyfetchSDK) -> None:
        number_2fa = await async_client.v1.auth.number_2fa.enable(
            password="password123",
        )
        assert number_2fa is None

    @parametrize
    async def test_raw_response_enable(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.auth.number_2fa.with_raw_response.enable(
            password="password123",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = await response.parse()
        assert number_2fa is None

    @parametrize
    async def test_streaming_response_enable(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.auth.number_2fa.with_streaming_response.enable(
            password="password123",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = await response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_method_get_status(self, async_client: AsyncStudyfetchSDK) -> None:
        number_2fa = await async_client.v1.auth.number_2fa.get_status()
        assert number_2fa is None

    @parametrize
    async def test_raw_response_get_status(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.auth.number_2fa.with_raw_response.get_status()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = await response.parse()
        assert number_2fa is None

    @parametrize
    async def test_streaming_response_get_status(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.auth.number_2fa.with_streaming_response.get_status() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = await response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_method_regenerate_backup_codes(self, async_client: AsyncStudyfetchSDK) -> None:
        number_2fa = await async_client.v1.auth.number_2fa.regenerate_backup_codes(
            password="password123",
        )
        assert number_2fa is None

    @parametrize
    async def test_raw_response_regenerate_backup_codes(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.auth.number_2fa.with_raw_response.regenerate_backup_codes(
            password="password123",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = await response.parse()
        assert number_2fa is None

    @parametrize
    async def test_streaming_response_regenerate_backup_codes(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.auth.number_2fa.with_streaming_response.regenerate_backup_codes(
            password="password123",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = await response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_method_send_code(self, async_client: AsyncStudyfetchSDK) -> None:
        number_2fa = await async_client.v1.auth.number_2fa.send_code(
            email="user@example.com",
        )
        assert number_2fa is None

    @parametrize
    async def test_raw_response_send_code(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.auth.number_2fa.with_raw_response.send_code(
            email="user@example.com",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        number_2fa = await response.parse()
        assert number_2fa is None

    @parametrize
    async def test_streaming_response_send_code(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.auth.number_2fa.with_streaming_response.send_code(
            email="user@example.com",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            number_2fa = await response.parse()
            assert number_2fa is None

        assert cast(Any, response.is_closed) is True
