# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from studyfetch_sdk import StudyfetchSDK, AsyncStudyfetchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestOrganizationInvites:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_preview(self, client: StudyfetchSDK) -> None:
        organization_invite = client.v1.auth.organization_invites.preview(
            "token",
        )
        assert organization_invite is None

    @parametrize
    def test_raw_response_preview(self, client: StudyfetchSDK) -> None:
        response = client.v1.auth.organization_invites.with_raw_response.preview(
            "token",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        organization_invite = response.parse()
        assert organization_invite is None

    @parametrize
    def test_streaming_response_preview(self, client: StudyfetchSDK) -> None:
        with client.v1.auth.organization_invites.with_streaming_response.preview(
            "token",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            organization_invite = response.parse()
            assert organization_invite is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_path_params_preview(self, client: StudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `token` but received ''"):
            client.v1.auth.organization_invites.with_raw_response.preview(
                "",
            )


class TestAsyncOrganizationInvites:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @parametrize
    async def test_method_preview(self, async_client: AsyncStudyfetchSDK) -> None:
        organization_invite = await async_client.v1.auth.organization_invites.preview(
            "token",
        )
        assert organization_invite is None

    @parametrize
    async def test_raw_response_preview(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.auth.organization_invites.with_raw_response.preview(
            "token",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        organization_invite = await response.parse()
        assert organization_invite is None

    @parametrize
    async def test_streaming_response_preview(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.auth.organization_invites.with_streaming_response.preview(
            "token",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            organization_invite = await response.parse()
            assert organization_invite is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_path_params_preview(self, async_client: AsyncStudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `token` but received ''"):
            await async_client.v1.auth.organization_invites.with_raw_response.preview(
                "",
            )
