# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from studyfetch_sdk import StudyfetchSDK, AsyncStudyfetchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestUpload:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_complete(self, client: StudyfetchSDK) -> None:
        upload = client.v1.organizations.logo.upload.complete()
        assert upload is None

    @parametrize
    def test_raw_response_complete(self, client: StudyfetchSDK) -> None:
        response = client.v1.organizations.logo.upload.with_raw_response.complete()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        upload = response.parse()
        assert upload is None

    @parametrize
    def test_streaming_response_complete(self, client: StudyfetchSDK) -> None:
        with client.v1.organizations.logo.upload.with_streaming_response.complete() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            upload = response.parse()
            assert upload is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_method_presigned_url(self, client: StudyfetchSDK) -> None:
        upload = client.v1.organizations.logo.upload.presigned_url()
        assert upload is None

    @parametrize
    def test_raw_response_presigned_url(self, client: StudyfetchSDK) -> None:
        response = client.v1.organizations.logo.upload.with_raw_response.presigned_url()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        upload = response.parse()
        assert upload is None

    @parametrize
    def test_streaming_response_presigned_url(self, client: StudyfetchSDK) -> None:
        with client.v1.organizations.logo.upload.with_streaming_response.presigned_url() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            upload = response.parse()
            assert upload is None

        assert cast(Any, response.is_closed) is True


class TestAsyncUpload:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @parametrize
    async def test_method_complete(self, async_client: AsyncStudyfetchSDK) -> None:
        upload = await async_client.v1.organizations.logo.upload.complete()
        assert upload is None

    @parametrize
    async def test_raw_response_complete(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.organizations.logo.upload.with_raw_response.complete()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        upload = await response.parse()
        assert upload is None

    @parametrize
    async def test_streaming_response_complete(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.organizations.logo.upload.with_streaming_response.complete() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            upload = await response.parse()
            assert upload is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_method_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        upload = await async_client.v1.organizations.logo.upload.presigned_url()
        assert upload is None

    @parametrize
    async def test_raw_response_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.organizations.logo.upload.with_raw_response.presigned_url()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        upload = await response.parse()
        assert upload is None

    @parametrize
    async def test_streaming_response_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.organizations.logo.upload.with_streaming_response.presigned_url() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            upload = await response.parse()
            assert upload is None

        assert cast(Any, response.is_closed) is True
