# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from studyfetch_sdk import StudyfetchSDK, AsyncStudyfetchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestModels:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_retrieve_available(self, client: StudyfetchSDK) -> None:
        model = client.v1.organizations.profile.models.retrieve_available()
        assert model is None

    @parametrize
    def test_raw_response_retrieve_available(self, client: StudyfetchSDK) -> None:
        response = client.v1.organizations.profile.models.with_raw_response.retrieve_available()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        model = response.parse()
        assert model is None

    @parametrize
    def test_streaming_response_retrieve_available(self, client: StudyfetchSDK) -> None:
        with client.v1.organizations.profile.models.with_streaming_response.retrieve_available() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            model = response.parse()
            assert model is None

        assert cast(Any, response.is_closed) is True


class TestAsyncModels:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @parametrize
    async def test_method_retrieve_available(self, async_client: AsyncStudyfetchSDK) -> None:
        model = await async_client.v1.organizations.profile.models.retrieve_available()
        assert model is None

    @parametrize
    async def test_raw_response_retrieve_available(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.organizations.profile.models.with_raw_response.retrieve_available()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        model = await response.parse()
        assert model is None

    @parametrize
    async def test_streaming_response_retrieve_available(self, async_client: AsyncStudyfetchSDK) -> None:
        async with (
            async_client.v1.organizations.profile.models.with_streaming_response.retrieve_available()
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            model = await response.parse()
            assert model is None

        assert cast(Any, response.is_closed) is True
