# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from studyfetch_sdk import StudyfetchSDK, AsyncStudyfetchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestAPIKeys:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_delete(self, client: StudyfetchSDK) -> None:
        api_key = client.v1.organizations.api_keys.delete(
            "keyId",
        )
        assert api_key is None

    @parametrize
    def test_raw_response_delete(self, client: StudyfetchSDK) -> None:
        response = client.v1.organizations.api_keys.with_raw_response.delete(
            "keyId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        api_key = response.parse()
        assert api_key is None

    @parametrize
    def test_streaming_response_delete(self, client: StudyfetchSDK) -> None:
        with client.v1.organizations.api_keys.with_streaming_response.delete(
            "keyId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            api_key = response.parse()
            assert api_key is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_path_params_delete(self, client: StudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `key_id` but received ''"):
            client.v1.organizations.api_keys.with_raw_response.delete(
                "",
            )

    @parametrize
    def test_method_api_keys(self, client: StudyfetchSDK) -> None:
        api_key = client.v1.organizations.api_keys.api_keys()
        assert api_key is None

    @parametrize
    def test_raw_response_api_keys(self, client: StudyfetchSDK) -> None:
        response = client.v1.organizations.api_keys.with_raw_response.api_keys()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        api_key = response.parse()
        assert api_key is None

    @parametrize
    def test_streaming_response_api_keys(self, client: StudyfetchSDK) -> None:
        with client.v1.organizations.api_keys.with_streaming_response.api_keys() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            api_key = response.parse()
            assert api_key is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_method_retrieve_api_keys(self, client: StudyfetchSDK) -> None:
        api_key = client.v1.organizations.api_keys.retrieve_api_keys()
        assert api_key is None

    @parametrize
    def test_raw_response_retrieve_api_keys(self, client: StudyfetchSDK) -> None:
        response = client.v1.organizations.api_keys.with_raw_response.retrieve_api_keys()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        api_key = response.parse()
        assert api_key is None

    @parametrize
    def test_streaming_response_retrieve_api_keys(self, client: StudyfetchSDK) -> None:
        with client.v1.organizations.api_keys.with_streaming_response.retrieve_api_keys() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            api_key = response.parse()
            assert api_key is None

        assert cast(Any, response.is_closed) is True


class TestAsyncAPIKeys:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @parametrize
    async def test_method_delete(self, async_client: AsyncStudyfetchSDK) -> None:
        api_key = await async_client.v1.organizations.api_keys.delete(
            "keyId",
        )
        assert api_key is None

    @parametrize
    async def test_raw_response_delete(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.organizations.api_keys.with_raw_response.delete(
            "keyId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        api_key = await response.parse()
        assert api_key is None

    @parametrize
    async def test_streaming_response_delete(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.organizations.api_keys.with_streaming_response.delete(
            "keyId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            api_key = await response.parse()
            assert api_key is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_path_params_delete(self, async_client: AsyncStudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `key_id` but received ''"):
            await async_client.v1.organizations.api_keys.with_raw_response.delete(
                "",
            )

    @parametrize
    async def test_method_api_keys(self, async_client: AsyncStudyfetchSDK) -> None:
        api_key = await async_client.v1.organizations.api_keys.api_keys()
        assert api_key is None

    @parametrize
    async def test_raw_response_api_keys(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.organizations.api_keys.with_raw_response.api_keys()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        api_key = await response.parse()
        assert api_key is None

    @parametrize
    async def test_streaming_response_api_keys(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.organizations.api_keys.with_streaming_response.api_keys() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            api_key = await response.parse()
            assert api_key is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_method_retrieve_api_keys(self, async_client: AsyncStudyfetchSDK) -> None:
        api_key = await async_client.v1.organizations.api_keys.retrieve_api_keys()
        assert api_key is None

    @parametrize
    async def test_raw_response_retrieve_api_keys(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.organizations.api_keys.with_raw_response.retrieve_api_keys()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        api_key = await response.parse()
        assert api_key is None

    @parametrize
    async def test_streaming_response_retrieve_api_keys(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.organizations.api_keys.with_streaming_response.retrieve_api_keys() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            api_key = await response.parse()
            assert api_key is None

        assert cast(Any, response.is_closed) is True
