# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from studyfetch_sdk import StudyfetchSDK, AsyncStudyfetchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestComponent:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @parametrize
    def test_method_complete_upload(self, client: StudyfetchSDK) -> None:
        component = client.v1.upload.component.complete_upload(
            "componentId",
        )
        assert component is None

    @parametrize
    def test_raw_response_complete_upload(self, client: StudyfetchSDK) -> None:
        response = client.v1.upload.component.with_raw_response.complete_upload(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = response.parse()
        assert component is None

    @parametrize
    def test_streaming_response_complete_upload(self, client: StudyfetchSDK) -> None:
        with client.v1.upload.component.with_streaming_response.complete_upload(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_path_params_complete_upload(self, client: StudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            client.v1.upload.component.with_raw_response.complete_upload(
                "",
            )

    @parametrize
    def test_method_get_presigned_url(self, client: StudyfetchSDK) -> None:
        component = client.v1.upload.component.get_presigned_url(
            "componentId",
        )
        assert component is None

    @parametrize
    def test_raw_response_get_presigned_url(self, client: StudyfetchSDK) -> None:
        response = client.v1.upload.component.with_raw_response.get_presigned_url(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = response.parse()
        assert component is None

    @parametrize
    def test_streaming_response_get_presigned_url(self, client: StudyfetchSDK) -> None:
        with client.v1.upload.component.with_streaming_response.get_presigned_url(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_path_params_get_presigned_url(self, client: StudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            client.v1.upload.component.with_raw_response.get_presigned_url(
                "",
            )

    @parametrize
    def test_method_upload_file(self, client: StudyfetchSDK) -> None:
        component = client.v1.upload.component.upload_file(
            "componentId",
        )
        assert component is None

    @parametrize
    def test_raw_response_upload_file(self, client: StudyfetchSDK) -> None:
        response = client.v1.upload.component.with_raw_response.upload_file(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = response.parse()
        assert component is None

    @parametrize
    def test_streaming_response_upload_file(self, client: StudyfetchSDK) -> None:
        with client.v1.upload.component.with_streaming_response.upload_file(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_path_params_upload_file(self, client: StudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            client.v1.upload.component.with_raw_response.upload_file(
                "",
            )

    @parametrize
    def test_method_upload_url(self, client: StudyfetchSDK) -> None:
        component = client.v1.upload.component.upload_url(
            "componentId",
        )
        assert component is None

    @parametrize
    def test_raw_response_upload_url(self, client: StudyfetchSDK) -> None:
        response = client.v1.upload.component.with_raw_response.upload_url(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = response.parse()
        assert component is None

    @parametrize
    def test_streaming_response_upload_url(self, client: StudyfetchSDK) -> None:
        with client.v1.upload.component.with_streaming_response.upload_url(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    def test_path_params_upload_url(self, client: StudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            client.v1.upload.component.with_raw_response.upload_url(
                "",
            )


class TestAsyncComponent:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @parametrize
    async def test_method_complete_upload(self, async_client: AsyncStudyfetchSDK) -> None:
        component = await async_client.v1.upload.component.complete_upload(
            "componentId",
        )
        assert component is None

    @parametrize
    async def test_raw_response_complete_upload(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.upload.component.with_raw_response.complete_upload(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = await response.parse()
        assert component is None

    @parametrize
    async def test_streaming_response_complete_upload(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.upload.component.with_streaming_response.complete_upload(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = await response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_path_params_complete_upload(self, async_client: AsyncStudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            await async_client.v1.upload.component.with_raw_response.complete_upload(
                "",
            )

    @parametrize
    async def test_method_get_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        component = await async_client.v1.upload.component.get_presigned_url(
            "componentId",
        )
        assert component is None

    @parametrize
    async def test_raw_response_get_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.upload.component.with_raw_response.get_presigned_url(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = await response.parse()
        assert component is None

    @parametrize
    async def test_streaming_response_get_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.upload.component.with_streaming_response.get_presigned_url(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = await response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_path_params_get_presigned_url(self, async_client: AsyncStudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            await async_client.v1.upload.component.with_raw_response.get_presigned_url(
                "",
            )

    @parametrize
    async def test_method_upload_file(self, async_client: AsyncStudyfetchSDK) -> None:
        component = await async_client.v1.upload.component.upload_file(
            "componentId",
        )
        assert component is None

    @parametrize
    async def test_raw_response_upload_file(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.upload.component.with_raw_response.upload_file(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = await response.parse()
        assert component is None

    @parametrize
    async def test_streaming_response_upload_file(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.upload.component.with_streaming_response.upload_file(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = await response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_path_params_upload_file(self, async_client: AsyncStudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            await async_client.v1.upload.component.with_raw_response.upload_file(
                "",
            )

    @parametrize
    async def test_method_upload_url(self, async_client: AsyncStudyfetchSDK) -> None:
        component = await async_client.v1.upload.component.upload_url(
            "componentId",
        )
        assert component is None

    @parametrize
    async def test_raw_response_upload_url(self, async_client: AsyncStudyfetchSDK) -> None:
        response = await async_client.v1.upload.component.with_raw_response.upload_url(
            "componentId",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        component = await response.parse()
        assert component is None

    @parametrize
    async def test_streaming_response_upload_url(self, async_client: AsyncStudyfetchSDK) -> None:
        async with async_client.v1.upload.component.with_streaming_response.upload_url(
            "componentId",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            component = await response.parse()
            assert component is None

        assert cast(Any, response.is_closed) is True

    @parametrize
    async def test_path_params_upload_url(self, async_client: AsyncStudyfetchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `component_id` but received ''"):
            await async_client.v1.upload.component.with_raw_response.upload_url(
                "",
            )
